
#include <stdio.h>
#include <assert.h>
#include "ports0.h"

void userMain(int argc, char** argv);

#define MAXTIMESLOCK   100000
#define MAXTHREADS     10000

int num_processors;
int numThreads;
int lockTimes;

void my_function();
void main(int argc, char* argv[])
{
   if (argc < 3)
   { 
     printf("Usage: %s <numThreads> <lockTimes>\n", argv[0]);
     return;
   }
   numThreads = atoi(argv[1]);
   lockTimes = atoi(argv[2]);

   assert(numThreads < MAXTHREADS);
   assert(lockTimes < MAXTIMESLOCK);
   printf("TestLocks: for %d processors and %d threads locking %d times\n",
	  num_processors, numThreads, lockTimes);
   ports0_init(argc, argv, 0);
   my_function();
   ports0_shutdown();
}

ports0_mutex_t mutex;

void my_function()
{
  int i, j;
  void localPongFunc(void*);
  int val;


  ports0_thread_t localPongThreadP[MAXTHREADS];
  int ret_val, total_ret_val;

  printf("my_function invoked\n");

  ports0_mutex_init (&mutex, 0);

  ports0_mutex_lock(&mutex);
  printf("Creating %d threads\n", numThreads);
  for (i = 0; i < numThreads; i++)
  {
      ports0_thread_create(&localPongThreadP[i], 0, localPongFunc,
			     (void*)(i+1));
  }
  ports0_mutex_unlock(&mutex);

  for (j = 0; j < numThreads; j++)
  {
      ports0_thread_join(&localPongThreadP[j], (void**)&ret_val);
      total_ret_val += ret_val;
  }
}

int globali = -1;

void localPongFunc(void* ignoredArg)
{
  int i = 0;
  int ret;
  int me = ll_CurrentContextId();
  int other = me == 0 ? 1 : 0;
  int inBuf, outBuf;

  while (++i < lockTimes)
  {
    threadYield(); 
    {
     ports0_mutex_lock(&mutex);
     ++globali;
     ports0_thread_yield();
     ports0_mutex_unlock(&mutex);
    }
  }
  if (ignoredArg)
     ports0_thread_exit(0);
}









